import{s as je,n as Re,o as We}from"../chunks/scheduler.182ea377.js";import{S as Je,i as Ye,g as r,s as o,p as M,A as Qe,h as n,f as s,c as a,j as l,q as w,m as h,k as i,v as t,a as u,r as y,d as A,t as T,u as K}from"../chunks/index.008d68e4.js";import{D as Z}from"../chunks/Docstring.7aec8b85.js";import{I as ye}from"../chunks/IconCopyLink.96bbb92b.js";function Xe(Ae){let f,ee,m,b,Y,C,me,U,Te="KDPM2AncestralDiscreteScheduler",te,k,Ke='The <code>KDPM2DiscreteScheduler</code> with ancestral sampling is inspired by the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper, and the scheduler is ported from and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',se,E,Ce='The original codebase can be found at <a href="https://github.com/crowsonkb/k-diffusion" rel="nofollow">crowsonkb/k-diffusion</a>.',re,g,D,Q,L,ge,V,ke="KDPM2AncestralDiscreteScheduler",ne,c,O,_e,z,Ee=`KDPM2DiscreteScheduler with ancestral sampling is inspired by the DPMSolver2 and Algorithm 2 from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating
the Design Space of Diffusion-Based Generative Models</a> paper.`,ve,B,Le=`This model inherits from <a href="/docs/diffusers/v0.25.0/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/v0.25.0/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,be,S,H,De,G,Oe=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,Se,$,N,$e,j,He="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",xe,x,F,Pe,R,Ne=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,oe,_,P,X,I,Me,W,Fe="SchedulerOutput",ae,v,q,we,J,Ie="Base class for the output of a scheduler’s <code>step</code> function.",ie;return C=new ye({}),L=new ye({}),O=new Z({props:{name:"class diffusers.KDPM2AncestralDiscreteScheduler",anchor:"diffusers.KDPM2AncestralDiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": Union = None"},{name:"use_karras_sigmas",val:": Optional = False"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.00085) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.012) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps. You can use a combination of <code>offset=1</code> and
<code>set_alpha_to_one=False</code> to make the last step use step 0 for the previous alpha product like in Stable
Diffusion.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/schedulers/scheduling_k_dpm_2_ancestral_discrete.py#L72"}}),H=new Z({props:{name:"scale_model_input",anchor:"diffusers.KDPM2AncestralDiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": Union"}],parametersDescription:[{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/schedulers/scheduling_k_dpm_2_ancestral_discrete.py#L179",returnDescription:`
<p>A scaled input sample.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),N=new Z({props:{name:"set_timesteps",anchor:"diffusers.KDPM2AncestralDiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": Union = None"},{name:"num_train_timesteps",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/schedulers/scheduling_k_dpm_2_ancestral_discrete.py#L209"}}),F=new Z({props:{name:"step",anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step",parameters:[{name:"model_output",val:": Union"},{name:"timestep",val:": Union"},{name:"sample",val:": Union"},{name:"generator",val:": Optional = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A random number generator.`,name:"generator"},{anchor:"diffusers.KDPM2AncestralDiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/v0.25.0/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/schedulers/scheduling_k_dpm_2_ancestral_discrete.py#L373",returnDescription:`
<p>If return_dict is <code>True</code>, <code>~schedulers.scheduling_ddim.SchedulerOutput</code> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/v0.25.0/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),I=new ye({}),q=new Z({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/schedulers/scheduling_utils.py#L50"}}),{c(){f=r("meta"),ee=o(),m=r("h1"),b=r("a"),Y=r("span"),M(C.$$.fragment),me=o(),U=r("span"),U.textContent=Te,te=o(),k=r("p"),k.innerHTML=Ke,se=o(),E=r("p"),E.innerHTML=Ce,re=o(),g=r("h2"),D=r("a"),Q=r("span"),M(L.$$.fragment),ge=o(),V=r("span"),V.textContent=ke,ne=o(),c=r("div"),M(O.$$.fragment),_e=o(),z=r("p"),z.innerHTML=Ee,ve=o(),B=r("p"),B.innerHTML=Le,be=o(),S=r("div"),M(H.$$.fragment),De=o(),G=r("p"),G.textContent=Oe,Se=o(),$=r("div"),M(N.$$.fragment),$e=o(),j=r("p"),j.textContent=He,xe=o(),x=r("div"),M(F.$$.fragment),Pe=o(),R=r("p"),R.textContent=Ne,oe=o(),_=r("h2"),P=r("a"),X=r("span"),M(I.$$.fragment),Me=o(),W=r("span"),W.textContent=Fe,ae=o(),v=r("div"),M(q.$$.fragment),we=o(),J=r("p"),J.innerHTML=Ie,this.h()},l(e){const d=Qe("svelte-1phssyn",document.head);f=n(d,"META",{name:!0,content:!0}),d.forEach(s),ee=a(e),m=n(e,"H1",{class:!0});var ce=l(m);b=n(ce,"A",{id:!0,class:!0,href:!0});var qe=l(b);Y=n(qe,"SPAN",{});var Ue=l(Y);w(C.$$.fragment,Ue),Ue.forEach(s),qe.forEach(s),me=a(ce),U=n(ce,"SPAN",{"data-svelte-h":!0}),h(U)!=="svelte-1v4p0y8"&&(U.textContent=Te),ce.forEach(s),te=a(e),k=n(e,"P",{"data-svelte-h":!0}),h(k)!=="svelte-1xsfzct"&&(k.innerHTML=Ke),se=a(e),E=n(e,"P",{"data-svelte-h":!0}),h(E)!=="svelte-loovl7"&&(E.innerHTML=Ce),re=a(e),g=n(e,"H2",{class:!0});var de=l(g);D=n(de,"A",{id:!0,class:!0,href:!0});var Ve=l(D);Q=n(Ve,"SPAN",{});var ze=l(Q);w(L.$$.fragment,ze),ze.forEach(s),Ve.forEach(s),ge=a(de),V=n(de,"SPAN",{"data-svelte-h":!0}),h(V)!=="svelte-1v4p0y8"&&(V.textContent=ke),de.forEach(s),ne=a(e),c=n(e,"DIV",{class:!0});var p=l(c);w(O.$$.fragment,p),_e=a(p),z=n(p,"P",{"data-svelte-h":!0}),h(z)!=="svelte-lafslh"&&(z.innerHTML=Ee),ve=a(p),B=n(p,"P",{"data-svelte-h":!0}),h(B)!=="svelte-1coxf99"&&(B.innerHTML=Le),be=a(p),S=n(p,"DIV",{class:!0});var le=l(S);w(H.$$.fragment,le),De=a(le),G=n(le,"P",{"data-svelte-h":!0}),h(G)!=="svelte-1rkfgpx"&&(G.textContent=Oe),le.forEach(s),Se=a(p),$=n(p,"DIV",{class:!0});var ue=l($);w(N.$$.fragment,ue),$e=a(ue),j=n(ue,"P",{"data-svelte-h":!0}),h(j)!=="svelte-1vzm9q"&&(j.textContent=He),ue.forEach(s),xe=a(p),x=n(p,"DIV",{class:!0});var pe=l(x);w(F.$$.fragment,pe),Pe=a(pe),R=n(pe,"P",{"data-svelte-h":!0}),h(R)!=="svelte-hi84tp"&&(R.textContent=Ne),pe.forEach(s),p.forEach(s),oe=a(e),_=n(e,"H2",{class:!0});var he=l(_);P=n(he,"A",{id:!0,class:!0,href:!0});var Be=l(P);X=n(Be,"SPAN",{});var Ge=l(X);w(I.$$.fragment,Ge),Ge.forEach(s),Be.forEach(s),Me=a(he),W=n(he,"SPAN",{"data-svelte-h":!0}),h(W)!=="svelte-1qoi9nz"&&(W.textContent=Fe),he.forEach(s),ae=a(e),v=n(e,"DIV",{class:!0});var fe=l(v);w(q.$$.fragment,fe),we=a(fe),J=n(fe,"P",{"data-svelte-h":!0}),h(J)!=="svelte-6ojmkw"&&(J.innerHTML=Ie),fe.forEach(s),this.h()},h(){i(f,"name","hf:doc:metadata"),i(f,"content",JSON.stringify(Ze)),i(b,"id","kdpm2ancestraldiscretescheduler"),i(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(b,"href","#kdpm2ancestraldiscretescheduler"),i(m,"class","relative group"),i(D,"id","diffusers.KDPM2AncestralDiscreteScheduler"),i(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(D,"href","#diffusers.KDPM2AncestralDiscreteScheduler"),i(g,"class","relative group"),i(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(P,"id","diffusers.schedulers.scheduling_utils.SchedulerOutput"),i(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(P,"href","#diffusers.schedulers.scheduling_utils.SchedulerOutput"),i(_,"class","relative group"),i(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,d){t(document.head,f),u(e,ee,d),u(e,m,d),t(m,b),t(b,Y),y(C,Y,null),t(m,me),t(m,U),u(e,te,d),u(e,k,d),u(e,se,d),u(e,E,d),u(e,re,d),u(e,g,d),t(g,D),t(D,Q),y(L,Q,null),t(g,ge),t(g,V),u(e,ne,d),u(e,c,d),y(O,c,null),t(c,_e),t(c,z),t(c,ve),t(c,B),t(c,be),t(c,S),y(H,S,null),t(S,De),t(S,G),t(c,Se),t(c,$),y(N,$,null),t($,$e),t($,j),t(c,xe),t(c,x),y(F,x,null),t(x,Pe),t(x,R),u(e,oe,d),u(e,_,d),t(_,P),t(P,X),y(I,X,null),t(_,Me),t(_,W),u(e,ae,d),u(e,v,d),y(q,v,null),t(v,we),t(v,J),ie=!0},p:Re,i(e){ie||(A(C.$$.fragment,e),A(L.$$.fragment,e),A(O.$$.fragment,e),A(H.$$.fragment,e),A(N.$$.fragment,e),A(F.$$.fragment,e),A(I.$$.fragment,e),A(q.$$.fragment,e),ie=!0)},o(e){T(C.$$.fragment,e),T(L.$$.fragment,e),T(O.$$.fragment,e),T(H.$$.fragment,e),T(N.$$.fragment,e),T(F.$$.fragment,e),T(I.$$.fragment,e),T(q.$$.fragment,e),ie=!1},d(e){e&&(s(ee),s(m),s(te),s(k),s(se),s(E),s(re),s(g),s(ne),s(c),s(oe),s(_),s(ae),s(v)),s(f),K(C),K(L),K(O),K(H),K(N),K(F),K(I),K(q)}}}const Ze={local:"kdpm2ancestraldiscretescheduler",sections:[{local:"diffusers.KDPM2AncestralDiscreteScheduler",title:"KDPM2AncestralDiscreteScheduler"},{local:"diffusers.schedulers.scheduling_utils.SchedulerOutput",title:"SchedulerOutput"}],title:"KDPM2AncestralDiscreteScheduler"};function et(Ae){return We(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ot extends Je{constructor(f){super(),Ye(this,f,et,Xe,je,{})}}export{ot as component};
